// -*-c++-*-
// Copyright (C) 1995 NEC Corporation, Tokyo, Japan.

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "EfPlayer.h"

static char _mpegformat[8]  = { 0x00, 0x00, 0x01, 0xb3 };
static char _jpegformat[8] = { 0xff, 0xd8, 0xff, 0xe0 };

boolean checking_mpeg(char* buff)
{
  int i;
  for( i = 0; i < 4; i++)
    if( buff[i] != _mpegformat[i] )
      break;
  if( 4 == i )
    return true;
  return false;
}

boolean checking_jpeg(char* buff)
{
  int i;
  for( i = 0; i < 4; i++)
    if( buff[i] != _jpegformat[i] )
      break;
  if( 4 == i )
    return true;
  return false;
}


DataType type_check( const char* n )
{
  char buff[256];
  char state[40];
  char* name;
  char* cp;
  int l = 0;
  DataType type;
  
  FILE* fp;
  int len = strlen(n);
  name = new char[ len+1 ];
  strcpy( name , n );

  if( name[len-1] == '/'){
    delete[] name;
    return NON;
  }
  if( (fp = fopen( name, "r" ) ) == NULL ){
    fprintf(stderr,"Could not open File %s\n", n );
    delete[] name;
    return NON;
  }
  fgets( buff, 80, fp );

  cp = buff;
  if(!strncmp("%!HYPER-VIDEO", buff, 13 )){
     delete[] name;
     fclose(fp);
     return AVFILE;
  }

  int cnt = 0;

  if( !strncmp("RAWMOVIE ", buff, 9 )){
    while(cp[0] != '\0'){
      if( cp[0] != ' ' && cp[1] == ' ' )
	cnt++;
      if( cnt == 3 && cp[0] == ' ' && cp [1] != ' ' && cp[1] != '\0'){
	sscanf(cp,"%s", state);
	l = atoi(state);
      }
      cp++;
    }
  }
  if(l == 1)
    type = MONO;
  else if(l == 8)
    type = COLOR;
  else{
     cp = name;
     int i;
     for( i = strlen( name )-1; 0 <= i; i-- )
	if( name[i] == '/' ){
	   cp = &name[i];
	   break;
	}
     for ( l = strlen( cp ) -1; cp[l] != '.'&& 0 <= l; l-- )
	;

     cp += l;

     if( checking_mpeg( buff ) )
        type = MPEG;
     else if( checking_jpeg( buff ) )
        type = JPEG;
     else if(!strcmp(".mono", cp ) )
	type = MONO;
     else
	type = NON;
  }
  
  delete[] name;
  fclose(fp);
  return type;
}

